from vcCommand import *

app = getApplication()
teach = getApplication().TeachContext

def SelectLimitation(args):
  if limitation.Value == True:
    errorRange.IsVisible = True
  if limitation.Value == False:
    errorRange.IsVisible = False

def OnStart():
  routine = teach.ActiveScope
  
  processStatement = routine.addStatement(VC_STATEMENT_PROCESS, teach.ActiveStatementIndex + 1, "rDetach")
  processStatement.Name = "Detach"+str(teach.ActiveStatementIndex+1)
  
  name = processStatement.getProperty('Name')
  base = processStatement.getProperty('Base')
  tool = processStatement.getProperty('Tool')
  
  processStatement.createProperty(VC_VECTOR, 'ChildVector')
  processStatement.createProperty(VC_STRING, 'ChildName')
  processStatement.createProperty(VC_BUTTON, 'SetChildVector')
  processStatement.createProperty(VC_BOOLEAN, 'Limitation')
  processStatement.createProperty(VC_REAL, 'ErrorRange')
  
  global limitation, errorRange
  limitation = processStatement.getProperty('Limitation')
  errorRange = processStatement.getProperty('ErrorRange')
  errorRange.IsVisible = False
  errorRange.Quantity = "Distance"
  errorRange.Value = 100
  limitation.OnChanged = SelectLimitation
  
  robot = teach.ActiveRobot 
  detachStatementScriptName = 'StatementScript_' + processStatement.Name
  detachStatementScript = robot.findBehaviour(detachStatementScriptName)
  if not detachStatementScript:
    detachStatementScript = robot.createBehaviour(VC_PYTHONPROCESSHANDLER, detachStatementScriptName)
  detachStatementScript.Script = '''
from vcPythonProcessHandler import *
import vcVector

sim = getSimulation()
world_container = sim.World.getBehavioursByType(VC_CONTAINER)[0]
app = getApplication()
snap = app.findCommand('interactiveSnap') 

def ChildPicked(arg):
  global childVector, childName
  target = snap.TargetNode.Component  
  childVector.Value = target.WorldPositionMatrix.P
  childName.Value = target.Name
  
def OnPickComponent(arg):
  snap.clear()   
  if 'Child' in arg.Name:
    snap.OnTargetSet = ChildPicked   
  snap.execute()

def hideOthers(statement):
  name = statement.getProperty('Name')
  name.IsVisible = False
  base = statement.getProperty('Base')
  base.IsVisible = False
  tool = statement.getProperty('Tool')
  tool.IsVisible = False

def setEvents(statement):
  global childVector, childName, limitation, errorRange
  
  childVector = statement.getProperty('ChildVector')
  childName = statement.getProperty('ChildName')
  limitation = statement.getProperty('Limitation')
  errorRange = statement.getProperty('ErrorRange')
  
  global setChildVector 
  setChildVector = statement.getProperty('SetChildVector')
  if setChildVector:
    if not setChildVector.OnChanged:
      setChildVector.OnChanged = OnPickComponent 

def OnStatementAdd(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)

def OnStatementModified(statement):
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
def OnStatementExecute(executor, statement):  
  # Hide others
  hideOthers(statement)
  
  # Set events
  setEvents(statement)
  
  child = None

  if childName.Value != None:
    for part in app.Components:
      if limitation.Value == True:
        if part.Name == childName.Value and (part.WorldPositionMatrix.P - childVector.Value).length() < errorRange.Value:
          child = part
          #child = app.findComponent(childName.Value)
      if limitation.Value == False:
        if part.Name == childName.Value:
          child = part
    world_container.grab(child)
    



'''
  processStatement.Process = detachStatementScript
  app.SelectionManager.setSelection(processStatement)

